/* Gruppe 13
 *
 * Autoren: Leon Wittwer, Rene Schaefer, Johannes Seiffarth
 */
package grp13;

public class MyHashMap 
{
	//own implementation of a hashmap
	//collision: concatenation
	protected Entry[] table;
	
	public MyHashMap( int capacity )
	{
		table = new Entry[capacity*2];
	}
	
	private int hash( String tr )
	{
		//hashing the string on the index
		//tried many functions, this was the best and fastest working idea
		long h = 0;
		char[] array = tr.toCharArray();
		for(int i = 0; i < array.length; i++)
		{
			h = 31*h + array[i];
		}
		return Math.abs((int)(h % table.length));
	}
	
	public void put( String key, int value )
	{
		//put elt in the hashmap
		int hash = hash(key);
		Entry e = table[hash];
		table[hash] = new Entry(hash, key, value, e);
	}
	
	public Integer get(String key)
	{
		//get elt
		int hash = hash(key);
		for ( Entry e = table[hash] ; e != null ; e = e.next )
		{
			if (e.key==key || key.equals(e.key))
				return e.value;
		}
		return null;
	}
	
	//one entry in the hashmap
	class Entry {
		String key;
		int value;
		Entry next;
		
		Entry(int h, String k, int v, Entry n)
		{
			value = v;
			next = n;
			key = k;
		}
	}
	
}