/* Gruppe 13
 *
 * Autoren: Leon Wittwer, Rene Schaefer, Johannes Seiffarth
 */
package grp13;

public class Treap 
{
	public TreapNode root;
	
	public Treap() {
		this.root = null;
	}
	
	public void insert ( int key, long prio ) {
		TreapNode n = new TreapNode (key, prio );
		bstIns (n);
		bubble (n);
	}
	
	public void bubble ( TreapNode n ) {
		while (n.parent != null && n.parent.prio < n.prio ) 
		{
			if (n.parent.right == n) {
				leftRotate (n.parent);
			} 
			else {
				rightRotate (n.parent);
			}
		}
	}
	
	public void bstIns(TreapNode node) { // Fuege node in den Baum this ein
		// Suche freien Platz
		TreapNode root = this.root, parent = null;
		while (root!=null) {
			parent = root;
			if (node.key < root.key) {
				root = root.left;
			} 
			else {
				root = root.right;
			}
		} 
		// Einfuegen
		node.parent = parent;
		if (parent==null) { // this war leer => neue Wurzel
			this.root = node;
		} 
		else if (node.key < parent.key) { // richtige Seite ...
			parent.left = node;
		} 
		else {
			parent.right = node;
		}
	}
	
	public void leftRotate(TreapNode node1) {
		TreapNode node2 = node1.right;
		// Baum B verschieben
		node1.right = node2.left;
		if (node1.right!=null) {
			node1.right.parent = node1;
		}
		// node2 wieder einhaengen
		node2.parent = node1.parent;
		if (node1.parent==null) { // node1 war die Wurzel
			this.root = node2;
		} 
		else if (node1 == node1.parent.left) { // war linkes Kind
			node2.parent.left = node2;
		} 
		else { // war rechtes Kind
			node2.parent.right = node2;
		}
		// node1 einhaengen
		node2.left = node1;
		node1.parent = node2;
	}
	
	public void rightRotate(TreapNode node2) {
		TreapNode node1 = node2.left;
		// Baum B verschieben
		node2.left = node1.right;
		if (node2.left!=null) {
			node2.left.parent = node2;
		}
		// node1 wieder einhaengen
		node1.parent = node2.parent;
		if (node1.parent==null) { // node1 war die Wurzel
			this.root = node1;
		} 
		else if (node2 == node2.parent.left) { // war linkes Kind
			node1.parent.left = node1;
		} 
		else { // war rechtes Kind
			node1.parent.right = node1;
		}
		// node1 einhaengen
		node1.right = node2;
		node2.parent = node1;
	}
	
	public int getHeight( TreapNode cur ) {
		if ( cur == null ) 
			return -1;
		
		int lefth = getHeight(cur.left);
		int righth = getHeight(cur.right);

		if(lefth > righth)
			return lefth + 1;
		else
			return righth +1;
	}
	/*public int getHeight( TreapNode cur ) {
		int cnt=0;
		while ( cur.left == null || cur.right == null ) {
			if ( cur.left == null && cur.right == null ) {
				return 1+cnt;
			}
			else if ( cur.left == null ) {
				cnt++;
				cur = cur.right;
				continue;
			}
			else if ( cur.right == null ) {
				cnt++;
				cur = cur.left;
				continue;
			}
		}
		return 1 + Math.max( getHeight(this.root.left), getHeight(this.root.right) );
	}*/
}
