/* Gruppe 5
 *
 * Autoren: anonym
 */
package grp5;

public class HashTable 
{
	private HashEntry[] hashentries;
	private final int size;

	public HashTable(int size)
	{
		if(size < 1) size = 10;
		hashentries = new HashEntry[size];
		this.size = size;
	}

	public void insert(TrieLeaf t, String s)
	{
		int arrpos = (int) hash(s);
		HashEntry newhash = new HashEntry(t, hashentries[arrpos], s);
		hashentries[arrpos] = newhash;
	}

	public TrieLeaf find(String s)
	{
		int arrpos = (int) hash(s);
		HashEntry cur = hashentries[arrpos];
		
		if (cur == null)
			return null;

		while (!cur.s.equals(s) && !(cur.next == null)){
			cur = cur.next;
		}
		if (cur.next == null)
			return null;
		else
			return cur.t;
	}

	private long hash(String s) 
	{
		long f = 31;
		int l = s.length();
		long hash = s.charAt(0) * f;
		
		for (int i = 3; i < l - 1; i += 3)
		{
			f = (f*31) % size;
			hash += s.charAt(i)*f; 
		}
		hash += s.charAt(l-1)*f;
		
		return ((hash >= 0 ? hash : -hash) % size);
	}

	private class HashEntry 
	{
		public final TrieLeaf t;
		public final HashEntry next;
		public final String s;

		public HashEntry(TrieLeaf t, HashEntry next, String s)
		{
			this.t = t;
			this.next = next;
			this.s = s;
		}
	}
}


