/* Gruppe 5
 *
 * Autoren: anonym
 */
package grp5;

import trigrams.TrigramAndCount;

public abstract class InnerTrieNode extends TrieNode{
	/*
	 * Der genaue Typ ist implementierungsabhaengig. Immer auf die Methoden des Knotens
	 * zurueckgreifen.
	 * Speichert die Referenzen auf die Kinderknoten, also auf Blaetter und innere Knoten.
	 */
	
	public InnerTrieNode(String prefix){
		super(prefix);
	}
	
	//Keine add-Methode ueberschreibt bereits bestehende Eintraege.
	//Add nur benutzen, wenn next() null oder ein Blatt zurueckgibt (Ist effizienter).
	
	//Fuegt den TrieNode unter diesem Knoten ein; nutzt das praefix des Knotens als
	//praefix.
	public abstract void add(TrieNode node);
	
	//Fuegt das Trigram t als Blatt an diesen Knoten ein, mit Restsuchstring prefix.
	public abstract void add(TrigramAndCount t, String prefix);
	
	//Fuegt das Trigram t als Blatt mit Praefix "" an diesen Knoten ein.
	public abstract void add(TrigramAndCount t);
	
	//Gibt den Knoten zurueck, dessen Praefix Praefix von s ist.
	//null, falls ein solcher nicht vorhanden.
	public abstract TrieNode next(String s);
	
	//Wie next(String s), aber gibt den Knoten mit kleinstem Praefix groesser oder gleich s aus.
	//null, wenn ein solcher nicht existiert.
	public abstract TrieNode nextCeil(String s);
	
	//Wie next(String s), aber gibt den Knoten mit groesstem Praefix kleiner oder gleich s aus.
	//null, wenn ein solcher nicht existiert.
	public abstract TrieNode nextFloor(String s);
	
	public abstract TrieNode nextGreater(String s);
	
	//Gibt den Knoten mit lexikografisch kleinstem Praefix zurueck. "" ist kleiner als jeder 
	//andere String.
	public abstract TrieNode getFirst();
	
	public abstract TrieNode getLast();
	
	public String toString(){
		return "(\"" + prefix + "\")";
	}
}
