package trigrams;
import java.util.HashMap;

public class IntegerTrigram implements Comparable<IntegerTrigram> {

	public IntegerTrigram(long w1, long w2, long w3) {
		this.w1 = w1;
		this.w2 = w2;
		this.w3 = w3;
	}
	
	public long getW1() {
		return w1;
	}
	
	public long getW2() {
		return w2;
	}

	public long getW3() {
		return w3;
	}
	
	public int compareTo(IntegerTrigram other) {
		if (w1 != other.getW1()) {
			return w1 < other.getW1() ? -1 : 1;
		}
		if (w2 != other.getW2()) {
			return w2 < other.getW2() ? -1 : 1;
		}
		return w3 < other.getW3() ? -1 : w3 == other.getW3() ? 0 : 1; 
	}
	
	public String toString() {
		return "<" + this.w1 + ", " + this.w2 + ", " + this.w3 + ">";
	}

	public String translate(HashMap<Long, String> dictionary) {
		StringBuilder result = new StringBuilder();
		
		result.append("<");
		result.append(dictionary.get(this.getW1()));
		result.append(", ");
		result.append(dictionary.get(this.getW2()));
		result.append(", ");
		result.append(dictionary.get(this.getW3()));
		result.append(">");
		result.append("[" + this.toString() + "]");
		
		return result.toString();
	}
	
	// Data members.
	private long w1;
	private long w2;
	private long w3;
}
